Package org.apache.sysds.hops.codegen.cplan

# Class CNodeCell

java.lang.Object
org.apache.sysds.hops.codegen.cplan.CNode
org.apache.sysds.hops.codegen.cplan.CNodeTpl
org.apache.sysds.hops.codegen.cplan.CNodeCell

All Implemented Interfaces:
  `Cloneable`

public class CNodeCell extends CNodeTpl

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`JAVA_TEMPLATE`

## Constructor Summary

Constructors
Constructor
Description
`CNodeCell(ArrayList<CNode> inputs, CNode output)`

## Method Summary

Modifier and Type
Method
Description
`CNodeTpl`
`clone()`
`String`
`codegen(boolean sparse, SpoofCompiler.GeneratorAPI _api)`
`int`
`compile(SpoofCompiler.GeneratorAPI api, String src)`
`boolean`
`containsSeq()`
`boolean`
`equals(Object o)`
`Types.AggOp`
`getAggOp()`
`SpoofCellwise.CellType`
`getCellType()`
`SpoofFusedOp.SpoofOutputDimsType`
`getOutputDimType()`
`SpoofCellwise.AggOp`
`getSpoofAggOp()`
`String`
`getTemplateInfo()`
`int`
`hashCode()`
`boolean`
`hasMultipleConsumers()`
`boolean`
`isSparseSafe()`
`boolean`
`isSupported(SpoofCompiler.GeneratorAPI api)`
`void`
`renameInputs()`
`boolean`
`requiredCastDtm()`
`void`
`setAggOp(Types.AggOp aggop)`
`void`
`setCellType(SpoofCellwise.CellType type)`
`void`
`setContainsSeq(boolean flag)`
`void`
`setMultipleConsumers(boolean flag)`
`void`
`setOutputDims()`
`void`
`setRequiresCastDtm(boolean flag)`
`void`
`setSparseSafe(boolean flag)`

### Methods inherited from class org.apache.sysds.hops.codegen.cplan.CNodeTpl

`addInput, codegen, getBeginLine, getGeneratorAPI, getInputHopIDs, getInputNames, resetVisitStatus, resetVisitStatusOutputs, rReorderCommutativeBinaryOps, setBeginLine, setGeneratorAPI`

### Methods inherited from class org.apache.sysds.hops.codegen.cplan.CNode

`createVarname, createVarname, getClassname, getDataType, getID, getInput, getNumCols, getNumRows, getOutput, getVarname, getVarname, getVectorLength, isGenerated, isLiteral, isVisited, resetGenerated, resetHash, resetVisitStatus, setDataType, setLiteral, setNumCols, setNumRows, setOutput, setVarName, setVisited, setVisited`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### JAVA_TEMPLATE

public static final String JAVA_TEMPLATE

See Also:
  - Constant Field Values

## Constructor Details

### CNodeCell

public CNodeCell(ArrayList<CNode> inputs, CNode output)

## Method Details

### setMultipleConsumers

public void setMultipleConsumers(boolean flag)

### hasMultipleConsumers

public boolean hasMultipleConsumers()

### setCellType

public void setCellType(SpoofCellwise.CellType type)

### getCellType

public SpoofCellwise.CellType getCellType()

### setAggOp

public void setAggOp(Types.AggOp aggop)

### getAggOp

public Types.AggOp getAggOp()

### getSpoofAggOp

public SpoofCellwise.AggOp getSpoofAggOp()

### setSparseSafe

public void setSparseSafe(boolean flag)

### isSparseSafe

public boolean isSparseSafe()

### setContainsSeq

public void setContainsSeq(boolean flag)

### containsSeq

public boolean containsSeq()

### setRequiresCastDtm

public void setRequiresCastDtm(boolean flag)

### requiredCastDtm

public boolean requiredCastDtm()

### renameInputs

public void renameInputs()

Specified by:
  `renameInputs` in class `CNodeTpl`

### codegen

public String codegen(boolean sparse, SpoofCompiler.GeneratorAPI _api)

Specified by:
  `codegen` in class `CNode`

### setOutputDims

public void setOutputDims()

Specified by:
  `setOutputDims` in class `CNode`

### clone

public CNodeTpl clone()

Specified by:
  `clone` in class `CNodeTpl`

### getOutputDimType

public SpoofFusedOp.SpoofOutputDimsType getOutputDimType()

Specified by:
  `getOutputDimType` in class `CNodeTpl`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `CNodeTpl`

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `CNodeTpl`

### getTemplateInfo

public String getTemplateInfo()

Specified by:
  `getTemplateInfo` in class `CNodeTpl`

### isSupported

public boolean isSupported(SpoofCompiler.GeneratorAPI api)

Specified by:
  `isSupported` in class `CNode`

### compile

public int compile(SpoofCompiler.GeneratorAPI api, String src)

Specified by:
  `compile` in class `CNodeTpl`